<?php
/*------------------------------------------------------------------------
bo-blog简易api接口通行证 for bo-blog 2.1.0
开发：宝宝酷
网址：www.baobaocool.com
时间：2008.06.22

该接口只能作为客户端（亦称反向通行证），必须有另一程序作为服务端才能使用。
部分代码参考了phpcms和phpwind。

目前成功整合phpwind 6.3 UTF8版，GBK版未测试，其他程序也未测试。

程序说明：
当服务端发送数据过来，进行验证字符串判断，验证信息合法则进行操作。
先检查用户是否存在，存在则更新用户信息，不存在则新增用户。
只处理如下信息到BO-BLOG数据库：
username（username）
password（userpsw）
email（email）
**（regtime）[新增时，当前时间]
**（usergroup）[新增时，1]
**（qq）[新增时，0]
**（gender）[新增时，0]
**（birthday）[新增时，0]
**（regip）[新增时，当前IP]

有任何问题请到我博客留言
--------------------------------------------------------------------------*/


require_once './global.php';

//参数赋值
$bo_action=$_GET['action'];
$bo_userdb=$_GET['userdb'];
$bo_forward=$_GET['forward'];
$bo_verify=$_GET['verify'];

//读取数据库API记录
$bo_api=$blog->getsinglevalue("{$db_prefix}api");

if($bo_api['status']=='0')
{
	exit('未开启通行证 Passport disabled');
}
elseif($bo_verify!=md5($bo_action.$bo_userdb.$bo_forward.$bo_api['key']))
{
	exit('非法请求 Illegal request');
}

$db_hash = $bo_api['key'];
$_db_hash = $db_hash;

//参数代码解密
parse_str(StrCode($bo_userdb,'DECODE'), $bo_user);

$bo_user_uid=$bo_user['uid'];
$bo_user_username=$bo_user['username'];
$bo_user_userpsw=$bo_user['password'];
$bo_user_email=$bo_user['email'];
$bo_user_cktime=$bo_user['cktime'] ? ($bo_user['cktime']=='F' ? 0 : $bo_user['cktime']) : 0;
$timestamp=time();
$bo_user_ip=$_SERVER["REMOTE_ADDR"];
$bo_forward = empty($bo_forward) ? $bo_api['url'] : $bo_forward;

if($bo_action=='login'){
	foreach($bo_user as $key=>$val){
		$bo_user[$key] = addslashes($val);
	}
	//判断合法性
	if(!$bo_user['time'] || !$bo_user_username || !$bo_user_userpsw){
		exit('数据检验失败，缺少参数！lack_data');
	}
	if($timestamp-$bo_user['time']>3600){
		exit('数据检验失败，无效数据！expired_error');
	}
	//读取数据库用户记录
	$bo_user_data=$blog->getbyquery("SELECT * FROM {$db_prefix}user where username='$bo_user[username]' LIMIT 0,1");;
	if($bo_user_data){
		//记录存在则更新改用户数据
		$bo_user_userid=$bo_user_data['userid'];
		$bo_user_sql="uid='$bo_user_uid',userpsw='$bo_user_userpsw',email='$bo_user_email'";
		db_query("UPDATE {$db_prefix}user SET $bo_user_sql WHERE userid=$bo_user_userid");
	}else{
		//用户记录不存在，则添加
		$bo_user_sql="'$bo_user_uid','$bo_user_username','$bo_user_userpsw','$bo_user_email','$timestamp','1','0','0','0','$bo_user_ip'";
		db_query("INSERT INTO {$db_prefix}user (uid,username,userpsw,email,regtime,usergroup,qq,gender,birthday,regip) VALUES($bo_user_sql)");
		$bo_user_userid=mysql_insert_id();
		db_query("UPDATE `{$db_prefix}counter` SET `users`=`users`+1");
	}
	//创建COOKIES
	setcookie ('userid', '', time()-3600);
	setcookie ('userpsw', '', time()-3600);
	setcookie ('uid', '', time()-3600);
	setcookie ('userid', $bo_user_userid, $bo_user_cktime);
	setcookie ('userpsw', $bo_user_userpsw, $bo_user_cktime);
	setcookie ('uid', $bo_user_uid, $bo_user_cktime);

	//返回前页
	header('location:'.$bo_forward);

}elseif($bo_action == 'quit'){
	//清除COOKIES
	setcookie ('userid', '', time()-3600);
	setcookie ('userpsw', '', time()-3600);
	setcookie ('uid', '', time()-3600);

	//返回前页
	header('location:'.$bo_forward);
}

function StrCode($string,$action='ENCODE')
{
	$key	= substr(md5($_SERVER["HTTP_USER_AGENT"].$GLOBALS['db_hash']),8,18);
	$string	= $action == 'ENCODE' ? $string : base64_decode($string);
	$len	= strlen($key);
	$code	= '';
	for($i=0; $i<strlen($string); $i++)
	{
		$k		= $i % $len;
		$code  .= $string[$i] ^ $key[$k];
	}
	$code = $action == 'DECODE' ? $code : base64_encode($code);
	return $code;
}
?>